## PAD RTEMS generic startup script 

# Set some abbreviations - looks redundant with ssrlApps/m68k-rtems/uC5282/bin/st.sys
ld    = cexpModuleLoad
unld  = cexpModuleUnload

printf("%s\n", getenv("PATH"))

# append /afs/slac/package/rtems/target/ssrlApps/m68k-rtems/uC5282/bin/rtems-gdb-stub.obj to path
buf    = malloc(2000)
(opath = getenv("PATH")) || (opath = "")
strcpy(buf,opath)
strcat(buf,":/boot/package/rtems/target/ssrlApps/m68k-rtems/uC5282/bin:")
setenv("PATH",buf,1)
free(buf)
buf    = 0
printf("%s\n", getenv("PATH"))
# load gdb stub
#ld("rtems-gdb-stub.obj")

# load our app
ld("bin/pad.obj") 

# nfsMount the filesystem for output data
#This configuration works while the PAD is on IFZ 134.79.21[6-9] subnet
# nfsMount("[uid.gid@]hostip", "path on host", "local mountpoint")
nfsMount("8412.2211@134.79.127.60","/vol/vol0/g.lcls/epics/ioc/data/LLRF/PAD","/data")

## Set common environment variables. eg. EPICS_TS_NTP_INET and PORTs
#cexpsh("../../../config/epicsEnvSetDev")

## Set app-specific environment variable for the PAD
epicsEnvSet ("EPICS_CA_MAX_ARRAY_BYTES", "600000")

## Register all support components
dbLoadDatabase("dbd/pad.dbd")
pad_registerRecordDeviceDriver(pdbbase) 

## Load record instances
dbLoadTemplate("db/padL1S.gen102_template")

## Set to 2 so that we see errors
devLongoutPadFlag=2
devLonginPadFlag=2
devWaveformPadFlag=2
devMbboPadFlag=2
devBoPadFlag=2
drvPadFlag = 2; # Note: padInitialise overrides drvPadFlag to DP_INFO and then resets to DP_ERROR
drvPadCfgFlag = 2;
drvPadScalFlag = 2;
drvPadIntrFlag = 2;
drvPadSSFlag = 2;
drvPadGenFlag = 2;
drvPadIfqFlag = 2;
drvPadRefFlag = 2;
drvPadBphFlag = 2;
drvPadSimpFlag = 2;

iocInit()

# Generic case does NOT sample at 102 MHz, so I and Q cannot be interlaced
# and use only one scalar
# force scalar waveforms to read (once)
dbpf("PRIM:LOCA:UNIT:PAD_0_SLI_WF.PROC","1")
dbpf("PRIM:LOCA:UNIT:PAD_1_SLI_WF.PROC","1")
dbpf("PRIM:LOCA:UNIT:PAD_2_SLI_WF.PROC","1")
dbpf("PRIM:LOCA:UNIT:PAD_3_SLI_WF.PROC","1")
dbpf("PRIM:LOCA:UNIT:PAD_0_SLQ_WF.PROC","1")
dbpf("PRIM:LOCA:UNIT:PAD_1_SLQ_WF.PROC","1")
dbpf("PRIM:LOCA:UNIT:PAD_2_SLQ_WF.PROC","1")
dbpf("PRIM:LOCA:UNIT:PAD_3_SLQ_WF.PROC","1")

# if testing by hand, stop some stuff from processing
#dbpf("PRIM:LOCA:UNIT:PAD_0.SCAN", "Passive")
#dbpf("PRIM:LOCA:UNIT:PAD_1.SCAN", "Passive")
#dbpf("PRIM:LOCA:UNIT:PAD_2.SCAN", "Passive")
#dbpf("PRIM:LOCA:UNIT:PAD_3.SCAN", "Passive")
#dbpf("PRIM:LOCA:UNIT:PAD_4.SCAN", "Passive")
#dbpf("PRIM:LOCA:UNIT:PAD_5.SCAN", "Passive")
#dbpf("PRIM:LOCA:UNIT:PAD_6.SCAN", "Passive")
#dbpf("PRIM:LOCA:UNIT:PAD_7.SCAN", "Passive")

#override what's set for the offset to the start of the data here
#padSetSampleOffset(channel, sample, n) usage: sample is the sample number (0 for most, can be 1 if BPH)
#                                     n is the number of 16 bit words to read 
#                                     after first 3 clock cycless. 
dbpf("PRIM:LOCA:UNIT:PAD_0_OFST","20")
dbpf("PRIM:LOCA:UNIT:PAD_1_OFST","20")
dbpf("PRIM:LOCA:UNIT:PAD_2_OFST","20")
dbpf("PRIM:LOCA:UNIT:PAD_3_OFST","20")
dbpf("PRIM:LOCA:UNIT:PAD_4_OFST","0")
dbpf("PRIM:LOCA:UNIT:PAD_5_OFST","0")
dbpf("PRIM:LOCA:UNIT:PAD_6_OFST","0")
dbpf("PRIM:LOCA:UNIT:PAD_7_OFST","0")

#override what's set for the size of the data here
#padSetSampleSize(channel, sample, n) usage: sample is the sample number (0 for most, can be 1 if BPH)
#                                   n must be a multiple of 4 since 
#                                   data in quadruples of (Q1,I2,Q3,I4) read 
#                                   (see comments in drvPad.c for more info)
dbpf("PRIM:LOCA:UNIT:PAD_0_SIZE","80")
dbpf("PRIM:LOCA:UNIT:PAD_1_SIZE","80")
dbpf("PRIM:LOCA:UNIT:PAD_2_SIZE","80")
dbpf("PRIM:LOCA:UNIT:PAD_3_SIZE","80")
dbpf("PRIM:LOCA:UNIT:PAD_4_SIZE","65536")
dbpf("PRIM:LOCA:UNIT:PAD_5_SIZE","65536")
dbpf("PRIM:LOCA:UNIT:PAD_6_SIZE","65536")
dbpf("PRIM:LOCA:UNIT:PAD_7_SIZE","65536")

#padSetDataFileStem("dayle") 	# The stem to start all data files with
                                # Format is "<stem><secPastEpoch>.dat"

# change directory to local mountpoint so that files don't need path to dir in their name
cd("/data") # for lcls-dev
#cd("/mntPt") # for klyron

rtems_gdb_start(0,0)

## Start any sequence programs. Note: RTEMS Cexp syntax
# Skip state machine for nonlin test
seq(&sncpad,"PRIM=PRIM,LOCA=LOCA,UNIT=UNIT,PAD=PAD") 

# for non-lin test
#padSetOperationMode(1)
#dbpf("PRIM:LOCA:UNIT:PAD_D_CALIB","1")
#padDisableIntr()
#padNonlin(1000)

