## L0B KLY PAD RTEMS STARTUP SCRIPT in lab PAD_KLY app

chdir("/boot/lcls/epics/iocTop/LLRF/Pad-Prod")
ld("bin/RTEMS-uC5282/pad-kly.obj") 

## Set common environment variables
< /boot/lcls/epics/iocCommon/All/Prod/pre_st.cmd

## /data now mapped by pre...
nfsMountsShow()

## Set app-specific environment variable for the PAD
epicsEnvSet ("EPICS_CA_MAX_ARRAY_BYTES", "600000")
#ALT: setenv("EPICS_CA_MAX_ARRAY_BYTES","20000000",1)

## Register all support components
dbLoadDatabase("dbd/pad.dbd")
pad_registerRecordDeviceDriver(pdbbase) 

## Load record instances
dbLoadTemplate("db/padKLY208.kly_template")
dbLoadRecords("db/iocAdmin.db","IOC=EIOC:IN20:RD08")

## Set to 2 so that we see errors
devLongoutPadFlag=2
devLonginPadFlag=2
devWaveformPadFlag=4
devMbboPadFlag=2
devBoPadFlag=2
drvPadFlag=2
drvPadCfgFlag=2
drvPadScalFlag=2
drvPadIntrFlag=2

# New: pre maps /data to /u1/lcls/epics/ioc/data/<hostname>
dbRestore("/data/EIOC-IN20-RD08.sav")

iocInit()

devWaveformPadFlag=2

# lower flags from 4 to 2 if too verbose for processing

# force scalar waveforms to read (once)
dbpf("KLYS:LI20:K8:L0B_0_SCL_WF.PROC","1")
dbpf("KLYS:LI20:K8:L0B_1_SCL_WF.PROC","1")
dbpf("KLYS:LI20:K8:L0B_2_SCL_WF.PROC","1")
dbpf("KLYS:LI20:K8:L0B_3_SCL_WF.PROC","1")

# override what's set for the offset to the start of the data here
#padSetSampleOffset(channel, sample, n) usage: sample is the sample number (0 for most, can be 1 if BPH)
#                                     n is the number of 16 bit words to read 
#                                     after first 3 clock cycless. 
dbpf("KLYS:LI20:K8:L0B_0_OFST.PROC","1") #<- causes it to crash
dbpf("KLYS:LI20:K8:L0B_1_OFST.PROC","1")
dbpf("KLYS:LI20:K8:L0B_2_OFST.PROC","1")
dbpf("KLYS:LI20:K8:L0B_3_OFST.PROC","1")
dbpf("KLYS:LI20:K8:L0B_4_OFST","0")
dbpf("KLYS:LI20:K8:L0B_5_OFST","0")
dbpf("KLYS:LI20:K8:L0B_6_OFST","0")
dbpf("KLYS:LI20:K8:L0B_7_OFST","0")
 
#override what's set for the size of the data here
#padSetSampleSize(channel, sample, n) usage: sample is the sample number (0 for most, can be 1 if BPH)
##                                   n must be a multiple of 4 since 
##                                   data in quadruples of (Q1,I2,Q3,I4) read 
##                                   (see comments in drvPad.c for more info)
dbpf("KLYS:LI20:K8:L0B_0_SIZE.PROC","1")
dbpf("KLYS:LI20:K8:L0B_1_SIZE.PROC","1")
dbpf("KLYS:LI20:K8:L0B_2_SIZE.PROC","1")
dbpf("KLYS:LI20:K8:L0B_3_SIZE.PROC","1")
dbpf("KLYS:LI20:K8:L0B_4_SIZE","65536")
dbpf("KLYS:LI20:K8:L0B_5_SIZE","65536")
dbpf("KLYS:LI20:K8:L0B_6_SIZE","65536")
dbpf("KLYS:LI20:K8:L0B_7_SIZE","65536")

# Start any sequence programs. Note: RTEMS Cexp syntax
# Skip state machine for nonlin test
seq(&sncpad,"PRIM=KLYS,LOCA=LI20,UNIT=K8,PAD=L0B") 

