## KlY24-8/PCAV3 HYBRID PAD RTEMS STARTUP SCRIPT at Sector ??-? PAD_PCAV3 app

chdir("/boot/epics/iocTop/LLRF/Pad-Dev")
#chdir("/boot/lcls/epics/iocTop/LLRF/Pad-Prod")
ld("bin/RTEMS-uC5282/pad-bph3.obj") 

## Set common environment variables
< /boot/epics/iocCommon/All/Dev/pre_st.cmd
#< /boot/lcls/epics/iocCommon/All/Prod/pre_st.cmd

## /data now mapped by pre...
nfsMountsShow()

## Register all support components
dbLoadDatabase("dbd/pad.dbd")
pad_registerRecordDeviceDriver(pdbbase) 

## Load record instances
dbLoadTemplate("db/padKLY248.bph3_template")
dbLoadRecords("db/iocAdmin.db","IOC=EIOC:LI24:RD02")

## Set to 2 so that we see errors
devLongoutPadFlag=2
devLonginPadFlag=2
devWaveformPadFlag=4
devMbboPadFlag=2
devBoPadFlag=2
drvPadFlag=2
drvPadCfgFlag=2
drvPadScalFlag=2
drvPadIntrFlag=2

# Note: pre maps /data to /u1/lcls/epics/ioc/data/<hostname>
#dbRestore("/data/EIOC-LI24-RD02.sav")

iocInit()

devWaveformPadFlag=2

# lower flags from 4 to 2 if too verbose for processing

# force scalar waveforms to read (once)
dbpf("KLYS:LI24:K8:TC3_0_SCL_WF.PROC","1")
dbpf("KLYS:LI24:K8:TC3_1_SCL_WF.PROC","1")
dbpf("KLYS:LI24:K8:TC3_2_SCL_WF.PROC","1")
# WILL BE USED BY PCAV3: dbpf("KLYS:LI24:K8:TC3_3_SCL_WF.PROC","1")

# while no CW
dbpf("KLYS:LI24:K8:TC3_0_OFST","0")
dbpf("KLYS:LI24:K8:TC3_1_OFST","0")
dbpf("KLYS:LI24:K8:TC3_2_OFST","0")
dbpf("PCAV:LI25:300:PH3_3_OF_0","0")
dbpf("PCAV:LI25:300:PH3_3_OF_1","32")

# once there is CW
#dbpf("KLYS:LI24:K8:TC3_0_OFST.PROC","1")
#dbpf("KLYS:LI24:K8:TC3_1_OFST.PROC","1")
#dbpf("KLYS:LI24:K8:TC3_2_OFST.PROC","1")
#dbpf("PCAV:LI25:300:PH3_3_OF_0.PROC","1")
#dbpf("PCAV:LI25:300:PH3_3_OF_1.PROC","1")

# regardless of CW
dbpf("KLYS:LI24:K8:TC3_4_OFST","0")
dbpf("KLYS:LI24:K8:TC3_5_OFST","0")
dbpf("KLYS:LI24:K8:TC3_6_OFST","0")
dbpf("PCAV:LI25:300:PH3_7_OFST","0")
 
# size must be a multiple of 4 since 
# data in quadruples of (Q1,I2,Q3,I4) read 
# (see comments in drvPad.c for more info)
# while no CW
dbpf("KLYS:LI24:K8:TC3_0_SIZE","24")
dbpf("KLYS:LI24:K8:TC3_1_SIZE","24")
dbpf("KLYS:LI24:K8:TC3_2_SIZE","24")
dbpf("PCAV:LI25:300:PH3_3_SZ_0","24")
dbpf("PCAV:LI25:300:PH3_3_SZ_1","24")

# once there is CW
#dbpf("KLYS:LI24:K8:TC3_0_SIZE.PROC","1")
#dbpf("KLYS:LI24:K8:TC3_1_SIZE.PROC","1")
#dbpf("KLYS:LI24:K8:TC3_2_SIZE.PROC","1")
#dbpf("PCAV:LI25:300:PH3_3_SZ_0.PROC","1")
#dbpf("PCAV:LI25:300:PH3_3_SZ_1.PROC","1")

# regardless of CW
dbpf("KLYS:LI24:K8:TC3_4_SIZE","65536")
dbpf("KLYS:LI24:K8:TC3_5_SIZE","65536")
dbpf("KLYS:LI24:K8:TC3_6_SIZE","65536")
dbpf("PCAV:LI25:300:PH3_7_SIZE","65536")

# Start any sequence programs. Note: RTEMS Cexp syntax
# Skip state machine for nonlin test
seq(&sncpad,"PRIM=KLYS,LOCA=LI24,UNIT=K8,PAD=TC3") 

