#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#define HIST_SIZE (10)
#define NUM_FILES (5)

int main(int argc, char **argv){
  int ii;
  int jj;
  int val;
  char filename[100];
  char histfilename[100];
  FILE *fp;
  int hist_size;
  int num_files;
  long hist[65536]; /* allocate for the max */
  char dirname[100];

  if (argc == 4) {
  hist_size = atoi(argv[1]);
  num_files = atoi(argv[2]); 
  strcpy(dirname, argv[3]);

  } else {
    printf("%s usage: [histogram size] [number of files] [dirname]\n", argv[0]);
    exit(1);
  }

/* THIS NEEDS TO BE IN A LOOP FOR DIR = zero, one, two, three */
/* Right now need to pass dirname: "zero","one","two","three" in as 3rd arg */ 

  for (ii=0; ii<hist_size; ii++) {
    hist[ii]=0;
  } 
  printf("Histogram zeroed to start\n");
  printf("hist_size is %d\n",hist_size);
  printf("num_files is %d\n",num_files);
 
  #ifdef DEBUG
  /* see what it is before you start */
  printf("Histogram is: \n");
  for (ii=0; ii<hist_size; ii++) {
    printf("%ld ", hist[ii]);
  } 
  #endif

  for (jj=0; jj<num_files; jj++) {
    sprintf(filename,"/nfs/slac/g/lcls/dev/epics/ioc/data/LLRF/PAD/TST/output/%s/%d.dat",dirname,jj);
    printf("opening %s to read %d values\n", filename, hist_size);
    fp = fopen(filename, "r");
    if (fp == NULL) {
      printf("Error opening %s\n",filename);
      exit(-1);
    }
    for (ii=0; ii<hist_size; ii++) {
      fscanf(fp,"%d",&val);
      val += 32768;
      hist[val]++;
    } 
    fclose(fp);
  }

  sprintf(histfilename,"/nfs/slac/g/lcls/dev/epics/ioc/data/LLRF/PAD/TST/output/%s/hist.dat",dirname);
  printf("Histogram is written to: %s\n", histfilename);
  fp = fopen(histfilename, "w");
  if (fp == NULL) {
    fprintf(stderr, "unable to open %s for writing\n", histfilename);
    exit(-1);
  }
  for (ii=0; ii<hist_size; ii++) {
    fprintf(fp, "%ld\n", hist[ii]);
  } 
  fprintf(fp, "\n");
  fclose(fp);

  return 0;
}

