#ifndef PAD_MACROS_H
#define PAD_MACROS_H

#define LOCAL static
#ifndef OK
#define OK (0)
#endif
#ifndef ERROR
#define ERROR (-1)
#endif
#ifndef NULL
#define NULL ('\0')
#endif
#define PAD_NUM_OP_MODES (4)
#define PAD_STARTING (0)
#define PAD_CALIBRATING (1)
#define PAD_CALIBRATION_DONE (2)
#define PAD_RUNNING (3)

#define PAD_NUM_CAL_MODES (3)
#define PAD_CAL_IDLE (0)
#define PAD_CAL_RQST (1)
#define PAD_CAL_DONE (2)

#define PAD_NUM_CHANNELS_ON_BOARD (4) /* Expect 4, but 2 and 1 PADs may exist */
#define PAD_FIFO_SIZE (65536)         /* The number of 16 bit words in 1 FIFO */
#define PAD_SAMPLE_SIZE (512)   /* The maximum size of a sample from the FIFO */

/* waveform types */
#define PAD_RAW (0)
#define PAD_SCALAR (1)
#define PAD_PROCESSED (2)
#define PAD_NON_INTERLACED_RAW (3)
#define PAD_RESERVED (4)
#define PAD_SCALAR_NON_INTERLACED_I (5)
#define PAD_SCALAR_NON_INTERLACED_Q (6)
#define PAD_PROCESSED_NON_INTERLACED_I (7)
#define PAD_PROCESSED_NON_INTERLACED_Q (8)
#define PAD_CONSTANT (9)
#define PAD_PCAV (10)

#endif
